// D.C.CONNECTION (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x400*5*80];		// 傫K

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{

	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

int getword(unsigned char *_p)
{
	int ret;
	ret = (_p[1]<<8) + _p[0];
	return ret;
}

struct fpos
{
	int trk;
	int sec;
	int ofs;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,d;
	int dn = -1;

	// Disk 1
	struct fpos md1[] =
	{
		{ 0x0b, 0x02, 0x008b, 0x0c22 },	//
		{ 0x0b, 0x05, 0x00af, 0x0c0e },	//
		{ 0x0d, 0x01, 0x023b, 0x0a5c },	//
		{ 0x0d, 0x04, 0x0099, 0x06e8 },	//
		{ 0x0d, 0x05, 0x0383, 0x0774 },	//
		{ 0x0e, 0x02, 0x02f9, 0x04dc },	//
		{ 0x0e, 0x03, 0x03d7, 0x0964 },	//
//		{ 0x14, 0x02, 0x008b, 0x0c22 },	// 
//		{ 0x14, 0x05, 0x00af, 0x0c0e },	// 
//		{ 0x16, 0x01, 0x023b, 0x0a5c },	// 
//		{ 0x16, 0x04, 0x0099, 0x06e8 },	// 
//		{ 0x16, 0x05, 0x0383, 0x0774 },	// 
//		{ 0x17, 0x02, 0x02f9, 0x04dc },	// 
//		{ 0x17, 0x03, 0x03d7, 0x0964 },	// 
		{ 0x1e, 0x04, 0x00fd, 0x0dfb },	//
		{ 0x00, 0x00, 0x0000, 0x0000 },	// 
	};

	// Disk 2
	struct fpos md2[] =
	{
//		{ 0x48, 0x04, 0x0197, 0x0c0e },	// 
//		{ 0x49, 0x05, 0x0323, 0x0a5c },	// 
//		{ 0x4a, 0x03, 0x0181, 0x06e8 },	// 
//		{ 0x4a, 0x05, 0x006b, 0x0774 },	// 
//		{ 0x4b, 0x01, 0x03e1, 0x04dc },	// 
//		{ 0x4b, 0x03, 0x00bf, 0x0964 },	// 
		{ 0x00, 0x00, 0x0000, 0x0000 },	//
	};

	// Disk 4
	struct fpos md4[] =
	{
		{ 0x12, 0x02, 0x00d4, 0x07e6 },	// 
		{ 0x41, 0x01, 0x002b, 0x0792 },	// 
		{ 0x41, 0x02, 0x03bf, 0x0880 },	// 
		{ 0x41, 0x05, 0x0041, 0x0a00 },	// 
		{ 0x42, 0x02, 0x0243, 0x07f6 },	// 
		{ 0x43, 0x01, 0x0383, 0x11a0 },	// 
		{ 0x00, 0x00, 0x0000, 0x0000 },	// 
	};

	if (argc < 2 || argc > 3)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file] (DiskNo.)\n",argv[0]);
		return 1;
	}

	if (argc==3)
	{
		// fBXNԍw
		dn = *argv[2]-'0';
		if (dn<1 || dn>4)
		{
		fprintf(stderr, "Usage: %s [d88file] (DiskNo.)\n",argv[0]);
		return 1;
		}
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x05);
		// fBXN
		if ((disk.ReadDATA1(0x00, 0x00, 0x00, 0x10, 0x01, buff, 0x100) && dn==-1) || dn==1)
		{
			printf("Disk 1 F܂.\n");
			fcut("BIOS", 0x00, 0x00, 0x00, 0x03, 0x01, 0x0000, 0x0100);
			fcut("PROG", 0x1e, 0x0f, 0x00, 0x01, 0x03, 0x0002, 0x40b9);
			for (i=0; md1[i].trk; i++)
			{
				sprintf(fname,"MUS1%02d",i);
				fcut(fname, md1[i].trk, md1[i].trk>>1, md1[i].trk&1, md1[i].sec, 0x03, md1[i].ofs, md1[i].size);
			}
			continue;
		}
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x03, buff, 0x400);
		if ((getword(buff)==0x3635 && dn==-1) || dn==2)
		{
			printf("Disk 2 F܂.\n");
			// ȃf[^̐؂o
			for (i=0; md2[i].trk; i++)
			{
				sprintf(fname,"MUS2%02d",i);
				fcut(fname, md2[i].trk, md2[i].trk>>1, md2[i].trk&1, md2[i].sec, 0x03, md2[i].ofs, md2[i].size);
			}
			continue;
		}
		else if ((getword(buff)==0x2b1a && dn==-1) || dn==3)
		{
			printf("Disk 3 F܂.\n");
			continue;
		}
		else if ((getword(buff)==0x4550 && dn==-1) || dn==4)
		{
			printf("Disk 4 F܂.\n");
			// ȃf[^̐؂o
			for (i=0; md4[i].trk; i++)
			{
				sprintf(fname,"MUS4%02d",i);
				fcut(fname, md4[i].trk, md4[i].trk>>1, md4[i].trk&1, md4[i].sec, 0x03, md4[i].ofs, md4[i].size);
			}
			continue;
		}
	}
	return 0;
}

